package com.novell.gso.jmstest.controller;

import javax.naming.Context;
import javax.naming.InitialContext;
import javax.servlet.ServletContextEvent;
import javax.servlet.ServletContextListener;

import org.apache.log4j.Appender;
import org.apache.log4j.ConsoleAppender;
import org.apache.log4j.Level;
import org.apache.log4j.Logger;
import org.apache.log4j.SimpleLayout;
import org.slf4j.LoggerFactory;

public class Listener implements ServletContextListener {
	public static org.slf4j.Logger logger = LoggerFactory.getLogger(Listener.class);

	/**
	 * Default constructor. 
	 */
	public Listener() {
	}

	/* (non-Javadoc)
	 * @see javax.servlet.ServletContextListener#contextInitialized(javax.servlet.ServletContextEvent)
	 */
	public void contextInitialized(ServletContextEvent event) {

		try {
	        // Logging
			Context env = (Context)new InitialContext().lookup("java:comp/env");

			String loggerName = (String)env.lookup("log4j/context-name");

			/*
			 * log4j Logger
			 * get the root logger and add an appender so we can see the logging on our dev box
			 */
			Logger logger = Logger.getRootLogger();

			/* addition logging for debug */
			String debug = System.getProperty("debug");

			if(debug != null && debug.equals("true")) {
				String appenderName = loggerName + "Appender";

				if(logger.getAppender(appenderName) == null) {
					Appender appender = new ConsoleAppender(new SimpleLayout());
					appender.setName(appenderName);
					logger.addAppender(appender);
				}

				logger.info("Entering debug mode");
			}
			
			// Try to silence Spring a little
			Logger springLogger = Logger.getLogger("org.springframework");
			springLogger.setLevel(Level.ERROR);
		}
		
		catch (Exception e) {
			Logger.getRootLogger().error("Exception", e);
		}

		logger.info("starting up");
	}


	public void contextDestroyed(ServletContextEvent event) {
		logger.info("shutting down");
	}
}