package com.novell.gso.jmstest.controller;

import javax.annotation.Resource;
import javax.jms.ConnectionFactory;
import javax.jms.JMSException;
import javax.jms.Topic;
import javax.servlet.http.HttpServletResponse;

import org.springframework.stereotype.Controller;
import org.springframework.ui.Model;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;

import com.novell.gso.jmstest.jms.SimplePublisher;

@Controller
@RequestMapping("/")
public class MainController {
	
	@Resource(name="myCF")
	private ConnectionFactory connectionFactory;
	
	@Resource(name="myTopic")
	private Topic myTopic;
	
	@RequestMapping(method=RequestMethod.GET)
	public String main(HttpServletResponse response, Model model) throws JMSException {
		response.setHeader("Cache-Control", "no-cache");
		
		model.addAttribute("hello", "Hello World!");

		return "index";
	}

	@RequestMapping(method=RequestMethod.POST)
	public String post(HttpServletResponse response, Model model) throws JMSException {
		response.setHeader("Cache-Control", "no-cache");
		
		// Send a message on button click
		SimplePublisher.sendMessage(connectionFactory, myTopic);
		
		model.addAttribute("hello", "Hello World!");  

		return "index";
	}
}
