package com.novell.gso.jmstest.jms;

import javax.jms.Connection;
import javax.jms.ConnectionFactory;
import javax.jms.JMSException;
import javax.jms.Session;
import javax.jms.Topic;
import javax.jms.TopicSubscriber;
import javax.naming.Context;
import javax.naming.InitialContext;

import org.slf4j.Logger;

import com.novell.gso.jmstest.controller.Listener;

public class JMSUtil {
	
	private static Logger logger = Listener.logger;
	
	public static final String JMS_JNDI = "jms/myCF";
	public static final String TOPIC_MYTOPIC = "jms/myTopic";

	/**
	 * @param jndi
	 * @return
	 */
	public static Connection getConnection(String jndi) {
		Connection connection = null;

		try {
			Context initContext = new InitialContext();
			ConnectionFactory factory = (ConnectionFactory) initContext.lookup("java:comp/env/" + jndi);
			connection = factory.createConnection();
		} catch (Exception e) {
			logger.error("Exception getting connection", e);
		}

		return connection;
	}
	
	
	/**
	 * @param connection
	 * @param session
	 * @param subscriber
	 */
	public static void closeConnection(Connection connection, Session session, TopicSubscriber subscriber) {
		if(subscriber != null) {
			try {
				subscriber.setMessageListener (null);
				subscriber.close ();
			}
			catch(JMSException ignore) {
			}
		}

		if(session != null) {
			try {
				session.close();
			}
			catch(JMSException ignore) {
			}
		}

		if(connection != null) {
			try {
				connection.close();
			}
			catch(JMSException ignore) {
			}
		}
	}


	/**
	 * @param jndi
	 * @return
	 */
	public static Topic getTopic(String jndi) {
		Topic topic = null;

		try {
			Context initContext = new InitialContext();
			topic = (Topic) initContext.lookup("java:comp/env/" + jndi);
		} catch (Exception e) {
			logger.error("Exception getting connection", e);
		}

		return topic;
	}
}
