package com.novell.gso.jmstest.jms;

import javax.jms.Connection;
import javax.jms.ConnectionFactory;
import javax.jms.JMSException;
import javax.jms.MessageProducer;
import javax.jms.Session;
import javax.jms.TextMessage;
import javax.jms.Topic;

import org.slf4j.Logger;

import com.novell.gso.jmstest.controller.Listener;

public class SimplePublisher {
	
	private static Logger logger = Listener.logger;
	
	private static final int MESSAGE_COUNT = 3;
	
	public static void sendMessage(ConnectionFactory connectionFactory, Topic topic) {
		Connection connection = null;
		Session session = null;
		MessageProducer producer = null;
		TextMessage message = null;

		try {
			connection = connectionFactory.createConnection();
			session = connection.createSession(false, Session.AUTO_ACKNOWLEDGE);
			producer = session.createProducer(topic);
			message = session.createTextMessage();

			for (int i = 1; i <= MESSAGE_COUNT; i++) {
				message.setText("This is message " + i);
				
				logger.info("Sending message: {}", message.getText());
				
				// Send!
				producer.send(message);
				
				try {
					Thread.sleep(500);
				} 
				catch (InterruptedException e) {
					logger.error("Error", e);
				}
			}
		} 
		catch (JMSException e) {
			logger.error("Error", e);
		} 
		finally {
			if (connection != null) {
				try {
					connection.close();
				} 
				catch (JMSException e) {
					logger.error("Error", e);
				}
			}
		}
	}
}
